public class Kvader {
   // z /* ... */ so oznaceni komentarji za razlago zakaj doloceni konstrukcijski prijemi
   // v "pravem" programu jih ne bi bilo!

   private int a; /* uporabnika ne zanima, kako imamo shranjene podatke */
   private int b;
   private int c;

   public static final int MIN_DOL_STR = 1; // minimalna dolzina stranice
   public static final int MAX_DOL_STR = 100; // maksimalna dolzina stranice
   /* Ker menimo, da je smiselno, da uporabnik neposredno vidi ti dve kolicini - dostop
      public. Spreminjati ju ne more zaradi final. Dostop: Kvader.MIN_DOL_STR

      Doloilo static - gre za razredno spremenljivko - 1 kopija za vse objekte, ne gre
      za lastnost posameznega razreda - ve kasneje
    */

   // vrni podatek

   public int povejA() { /* omogocimo uporabniku dostop do vrednosti zanj zanimivih podatkov */
      return a;
   }
   public int povejB() {
      return b;
   }
   public int povejC() {
      return c;
   }

   private boolean kontrola(int x) /* pomozna metoda, zato private */
   { // preverimo, ce velja MIN_DOL_STR <= x <= MAX_DOL_STR
     return ((MIN_DOL_STR <= x) && (x <= MAX_DOL_STR));
    }

   // nastavi podatek

   public void stranicaA(int a) { /* omogocimo uporabniku spreminjanje podatkov */
   // Ce je podatek v mejah med 1 in 100, ga spremenimo, drugace pustimo
   // taksnega, kot je
      if (kontrola(a))
        this.a = a;  /* this je potreben, da locimo med imenom podatka objekta in parametrom a */
                     /* verjetno bi bilo bolj smiselno namesto a parameter poimenovati s ali kako drugae */
   }
   public void stranicaB(int a) {
   // Ce je podatek v mejah med 1 in 100, ga spremenimo, drugace pustimo
   // taksnega, kot je
      if (kontrola(a))
        this.b = a;   /* this v nasprotju s prejsnjo metodo tu ni potreben.
                       se vedno pa velja, da bi bilo boljse, da bi parameter a poimenovali
                       drugace - npr. s */
   }
   public void stranicaC(int s) {
   // Ce je podatek v mejah med 1 in 100, ga spremenimo, drugace pustimo
   // taksnega, kot je
      if (kontrola(s)) /* na ta nacin bi verjetno "zares" sprogramirali tudi
                          zgornji metodi */
      c = s;
   }

    //...........................................
    // konstruktorji

    public Kvader()
    {
      a = b = c = 1;
   }

    public Kvader(int s)
    { // kocka s stranico s. e podatek ni v redu - kocka z robom 1
      if (!kontrola(s)) s = 1; // ce podatek ni v mejah, ga postavimo na 1
      a = b = c = s;
   }

    public Kvader(int s1, int s2, int s3)
    { // kvader s1 x s2 x s3
      // Ce kak podatek ni v redu - ga postavimo na 1
      if (!kontrola(s1)) s1 = 1; // ce podatek ni v mejah, ga postavimo na 1
      a = s1;

      if (!kontrola(s2)) s2 = 1; // ce podatek ni v mejah, ga postavimo na 1
      b = s2;

      if (!kontrola(s3)) s3 = 1; // ce podatek ni v mejah, ga postavimo na 1
      c = s3;
    }

    public Kvader(Kvader sk)
    { // Novi objekt je kopija obstojecega objekta sk
      this.a = sk.a; /* this ni potreben */
      stranicaB(sk.b); /* tudi znotraj razreda se splaca uporabljati metode za delo s podatki */
      stranicaC(sk.c); /* ceprav imamo neposreden dostop do spremenljivk, saj nam ob morebitni
                          spremembi predstavitve ni potrebno toliko popravljati! */

    }

    //
    // --------------- to String
    //
    public String toString()  /* prekrivanje metode iz razreda Object */
    {  // Metoda vrne podatek v obliki Kvader: a x b x c
       return "Kvader: " + povejA() + " x " + povejB() + " x " + povejC();
       /* tudi znotraj razreda se splaca uporabljati metode za delo s podatki
          ceprav imamo neposreden dostop do spremenljivk, saj nam ob morebitni
          spremembi predstavitve ni potrebno toliko popravljati! */
    }


} // class Kvader


